"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _useFormApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _fieldArray = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/field-array"));

var _reactJss = require("react-jss");

var _buttons = require("@blueprintjs/core/lib/cjs/components/button/buttons.js");

var _intent = require("@blueprintjs/core/lib/cjs/common/intent.js");

var _formGroup = require("@blueprintjs/core/lib/cjs/components/forms/formGroup.js");

var _blueprintContext = _interopRequireDefault(require("../blueprint-context/blueprint-context"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useStyles = (0, _reactJss.createUseStyles)({
  addContainer: {
    display: 'flex',
    flexFlow: 'row-reverse',
    marginBottom: 15
  },
  remove: {
    marginBottom: 15
  }
});

var ArrayItem = function ArrayItem(_ref) {
  var remove = _ref.remove,
      fields = _ref.fields,
      name = _ref.name,
      removeLabel = _ref.removeLabel,
      ArrayItemProps = _ref.ArrayItemProps,
      RemoveButtonProps = _ref.RemoveButtonProps,
      disabledRemove = _ref.disabledRemove;
  var formOptions = (0, _useFormApi["default"])();

  var _useStyles = useStyles(),
      removeCss = _useStyles.remove;

  var editedFields = fields.map(function (field) {
    return _objectSpread(_objectSpread({}, field), field.name ? {
      name: "".concat(name, ".").concat(field.name)
    } : {
      name: name
    });
  });
  return /*#__PURE__*/_react["default"].createElement("div", ArrayItemProps, formOptions.renderForm(editedFields, formOptions), /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    onClick: remove,
    intent: _intent.Intent.DANGER,
    disabled: disabledRemove
  }, RemoveButtonProps, {
    className: (0, _clsx["default"])(removeCss, RemoveButtonProps && RemoveButtonProps.className)
  }), removeLabel));
};

ArrayItem.propTypes = {
  remove: _propTypes["default"].func,
  fields: _propTypes["default"].array,
  name: _propTypes["default"].string,
  removeLabel: _propTypes["default"].node,
  ArrayItemProps: _propTypes["default"].object,
  RemoveButtonProps: _propTypes["default"].object,
  disabledRemove: _propTypes["default"].bool
};

var FieldArray = function FieldArray(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      defaultItem = _useFieldApi.defaultItem,
      fields = _useFieldApi.fields,
      arrayValidator = _useFieldApi.arrayValidator,
      label = _useFieldApi.label,
      description = _useFieldApi.description,
      buttonLabels = _useFieldApi.buttonLabels,
      AddContainerProps = _useFieldApi.AddContainerProps,
      AddButtonProps = _useFieldApi.AddButtonProps,
      RemoveButtonProps = _useFieldApi.RemoveButtonProps,
      ArrayItemProps = _useFieldApi.ArrayItemProps,
      FieldArrayProps = _useFieldApi.FieldArrayProps,
      noItemsMessage = _useFieldApi.noItemsMessage,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      helperText = _useFieldApi.helperText,
      isRequired = _useFieldApi.isRequired,
      FormGroupProps = _useFieldApi.FormGroupProps,
      maxItems = _useFieldApi.maxItems,
      minItems = _useFieldApi.minItems;

  var _useContext = (0, _react.useContext)(_blueprintContext["default"]),
      required = _useContext.required;

  var _useStyles2 = useStyles(),
      addContainer = _useStyles2.addContainer;

  var error = meta.error,
      touched = meta.touched,
      submitError = meta.submitError;
  var showError = (validateOnMount || touched) && (error || submitError);
  var text = showError ? error : helperText || description;
  var intent = showError && error && {
    intent: _intent.Intent.DANGER
  };
  var labelInfo = isRequired && {
    labelInfo: required
  };

  var combinedLabels = _objectSpread({
    add: 'Add',
    remove: 'Remove'
  }, buttonLabels);

  return /*#__PURE__*/_react["default"].createElement(_formGroup.FormGroup, (0, _extends2["default"])({
    helperText: text,
    label: label
  }, labelInfo, FormGroupProps, intent), /*#__PURE__*/_react["default"].createElement(_fieldArray["default"], {
    name: props.name,
    validate: arrayValidator
  }, function (fieldArrayProps) {
    return /*#__PURE__*/_react["default"].createElement("div", FieldArrayProps, fieldArrayProps.fields.length === 0 && noItemsMessage, fieldArrayProps.fields.map(function (name, index) {
      return /*#__PURE__*/_react["default"].createElement(ArrayItem, {
        key: index,
        remove: function remove() {
          return fieldArrayProps.fields.remove(index);
        },
        name: name,
        fields: fields,
        removeLabel: combinedLabels.remove,
        ArrayItemProps: ArrayItemProps,
        RemoveButtonProps: RemoveButtonProps,
        disabledRemove: fieldArrayProps.fields.length <= minItems
      });
    }), /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, AddContainerProps, {
      className: (0, _clsx["default"])(addContainer, AddContainerProps && AddContainerProps.className)
    }), /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
      onClick: function onClick() {
        return fieldArrayProps.fields.push(defaultItem);
      },
      intent: _intent.Intent.SUCCESS,
      disabled: fieldArrayProps.fields.length >= maxItems
    }, AddButtonProps), combinedLabels.add)));
  }));
};

FieldArray.propTypes = {
  name: _propTypes["default"].string,
  defaultItem: _propTypes["default"].any,
  fields: _propTypes["default"].array,
  label: _propTypes["default"].node,
  description: _propTypes["default"].node,
  buttonLabels: _propTypes["default"].object,
  AddContainerProps: _propTypes["default"].object,
  AddButtonProps: _propTypes["default"].object,
  RemoveButtonProps: _propTypes["default"].object,
  ArrayItemProps: _propTypes["default"].object,
  FormGroupProps: _propTypes["default"].object,
  FieldArrayProps: _propTypes["default"].object,
  noItemsMessage: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  maxItems: _propTypes["default"].number,
  minItems: _propTypes["default"].number
};
FieldArray.defaultProps = {
  noItemsMessage: 'No items'
};
var _default = FieldArray;
exports["default"] = _default;